import os
import re
import networkx as nx

class PCHBSync():

    inputs = []
    outputs = []
    num_gates = 0
    num_Bool_gates=0
    num_levels = 0
    num_comps = 0
    num_not = 0
    num_RegN = 0
    num_RegD = 0
    num_component = 0
    
    gate_inputs_number= 0
    gate_info = dict()
    Bool_gate_info= dict()
    comp_info= dict()
    not_info= dict()
    RegN_info= dict()
    RegD_info = dict()
    component_info = dict()
    
    
    

    def __init__(self, netlist, outfile, outfile1):
        self.netlist = netlist
        self.outfile = outfile
        self.outfile1 = outfile1
#        self.outfile2 = outfile2
        self._process_netlist()

    def _process_netlist(self):
        """Process the netlist file to identify inputs, outputs, and gates used"""
        with open(self.netlist, 'r') as netlist_file:
            var= netlist_file.readline().rstrip().split(',')
            for x in var:
                self.inputs.append(x)
#            print (self.inputs)
            var= netlist_file.readline().rstrip().split(',')
            for x in var:             
                self.outputs.append(x)
#            print (self.outputs)
          
            for line in netlist_file:
#               As Completion units donot have any 'level' column
                (gate, others1) = line.split(' ',1)
                if (gate!='Comp') and (gate!= 'RegD2') and (gate!= 'RegN2'):
                    (level, inputs, reset, Rack, Lack, output) = others1.split(' ',5)
                    self.num_component += 1
                    self.component_info[self.num_component] = dict()
                    self.component_info[self.num_component]['type'] = gate
                    self.component_info[self.num_component]['level'] = level
                    self.component_info[self.num_component]['reset'] = reset
                    self.component_info[self.num_component]['inputs'] = inputs.split(',')
                    self.component_info[self.num_component]['input_var']=[]
                    self.component_info[self.num_component]['input_var1']=[]
                    self.component_info[self.num_component]['input_var2']=[]
                    self.component_info[self.num_component]['input_var1_rail1']=[]
                    self.component_info[self.num_component]['input_var2_rail2']=[]
                    for i in self.component_info[self.num_component]['inputs']:
                        mat1= re.search (r'((?P<var>[A-z]+[0-9]+)_.*)',i)
                        n= mat1.group('var')
                        self.component_info[self.num_component]['input_var'].append(n)
                                            
                    
                    self.component_info[self.num_component]['outputs'] = output.rstrip().split(',')
                    self.component_info[self.num_component]['rack'] = Rack
                    self.component_info[self.num_component]['lack'] = Lack
#                    print (self.component_info[self.num_component]['outputs'])
               
                if (gate == 'RegN2'):
                    (level, inputs, reset, Rack, Lack, output) = others1.split(' ',5)
                    self.num_component += 1
                    self.component_info[self.num_component] = dict()
                    self.component_info[self.num_component]['type'] = gate
                    self.component_info[self.num_component]['level'] = level
                    self.component_info[self.num_component]['reset'] = reset
                    self.component_info[self.num_component]['init_inputs'] = inputs.split(',')
#                    print(self.component_info[self.num_component]['init_inputs'])
                    self.component_info[self.num_component]['inputs']= []
                    self.component_info[self.num_component]['outputs']= []
                    for m in self.component_info[self.num_component]['init_inputs']:
                        if (m!= 'reset1_1'):
                            self.component_info[self.num_component]['inputs'].append(m)
#                    print(self.component_info[self.num_component]['inputs'])        
                    self.component_info[self.num_component]['input_var']=[]
                    for i in self.component_info[self.num_component]['inputs']:
                        mat1= re.search (r'((?P<var>[A-z]+[0-9]+)_.*)',i)
                        n= mat1.group('var')
                        self.component_info[self.num_component]['input_var'].append(n)
#                    print (self.component_info[self.num_component]['input_var'])
                    self.component_info[self.num_component]['outputs'] = output.rstrip().split(',')
                    
                    self.component_info[self.num_component]['rack'] = Rack
                    self.component_info[self.num_component]['lack'] = Lack
                    
                
                if (gate == 'RegD2'):
                    (level, inputs, reset, Rack, Lack, output) = others1.split(' ',5)
                    self.num_component += 1
                    self.component_info[self.num_component] = dict()
                    self.component_info[self.num_component]['type'] = gate
                    self.component_info[self.num_component]['level'] = level
                    self.component_info[self.num_component]['reset'] = reset
                    self.component_info[self.num_component]['init_inputs'] = inputs.split(',')
#                    print(self.component_info[self.num_component]['init_inputs'])
                    self.component_info[self.num_component]['inputs']= []
                    self.component_info[self.num_component]['outputs']= []
                    for m in self.component_info[self.num_component]['init_inputs']:
                        if (m!= 'reset1_1'):
                            self.component_info[self.num_component]['inputs'].append(m)
#                    print(self.component_info[self.num_component]['inputs'])        
                    self.component_info[self.num_component]['input_var']=[]
                    for i in self.component_info[self.num_component]['inputs']:
                        mat1= re.search (r'((?P<var>[A-z]+[0-9]+)_.*)',i)
                        n= mat1.group('var')
                        self.component_info[self.num_component]['input_var'].append(n)
#                    print (self.component_info[self.num_component]['input_var'])
                    self.component_info[self.num_component]['init_outputs'] = output.rstrip().split(',')
                    for x in self.component_info[self.num_component]['init_outputs']:
                        mat1= re.search (r'((?P<var>[A-z]+[0-9]+)_.*)',x)
                        n= mat1.group('var')
                        string = n+ '_1'+ n+ '_0'
                    self.component_info[self.num_component]['outputs'].append(string)
                    self.component_info[self.num_component]['rack'] = Rack
                    self.component_info[self.num_component]['lack'] = Lack
                    
#            for x in range (1, self.num_component+1):
#                print (self.component_info[x]['inputs'])
#                print (self.component_info[x]['rack'])
#                print (self.component_info[x]['lack'])
#                print (self.component_info[x]['outputs'])
                
                if (gate == 'Comp'):
                    self.num_comps += 1
                    self.comp_info[self.num_comps] = dict()
                    self.comp_info[self.num_comps]['type'] = gate
                    (gate_inputs, gate_op)= others1.split(' ',2)
                    self.comp_info[self.num_comps]['comp_inputs'] = gate_inputs.split(',')
                    self.comp_info[self.num_comps]['comp_outputs'] = gate_op.rstrip().split(' ')
#                    print (self.comp_info[self.num_comps]['comp_outputs'][0])

    def connection_file(self): 
        with open(self.outfile1, 'w') as smt2_file:
            error_flag=0
           
            for x in range (1,self.num_component+1):
                for i in  self.component_info[x]['outputs'] :
                        
                        mat2= re.search(r'((?P<var1>[A-z]+[0-9]+)_.*)',i)
                        mat3= re.search (r'(([A-z]+[0-9]+)_((?P<rail1>[0-9]+)))',i)
                        mat4= re.search(r'(((?P<var2>[A-z]+[0-9]+)_).$)',i)
                        #mat4= re.search (r'(([A-z]+[0-9]+)_[0-9]+((?P<var2>[A-z]+[0-9]+)_))',i)
                        mat5= re.search (r'(?P<rail2>[0-9]+)$.*',i)
                    
                        n1= mat2.group('var1')
                        n2= mat4.group('var2')
                        n3= mat3.group('rail1')
                        n4= mat5.group('rail2')
                        if n1!=n2:
                            smt2_file.write (" ERROR: INCORRECT OUTPUT DUAL RAIL VARIABLE mismatch "+ n1 +' or '+ n2 +" in component "+ str(x) + "!!!!!!!!!!!! \n")
                            error_flag=1
                        if (n3==n4):
                            smt2_file.write (" RAIL SHORT ERROR: CHECK component "+ str(x)+ " outputs !!!!!!!!!!!! \n")
                            error_flag=1
                        if ((int(n3)>1) or (int(n4)>1)):
                            smt2_file.write (" RAIL Value does not fall in [0,1] ERROR: CHECK component "+ str(x)+ " outputs !!!!!!!!!!!! \n")
                            error_flag=1    
                            
                            
            for x in range (1,self.num_component+1):
                for i in self.component_info[x]['inputs']:
                        
                        mat2= re.search(r'((?P<var1>[A-z]+[0-9]+)_.*)',i)
                        mat3= re.search (r'(([A-z]+[0-9]+)_((?P<rail1>[0-9]+)))',i)
                        mat4= re.search(r'(((?P<var2>[A-z]+[0-9]+)_).$)',i)
                        #mat4= re.search (r'(([A-z]+[0-9]+)_[0-9]+((?P<var2>[A-z]+[0-9]+)_))',i)
                        mat5= re.search (r'(?P<rail2>[0-9]+)$.*',i)
                    
                        n1= mat2.group('var1')
                        n2= mat4.group('var2')
                        n3= mat3.group('rail1')
                        n4= mat5.group('rail2')
                        if n1!=n2:
                            smt2_file.write (" ERROR: INCORRECT INPUT DUAL RAIL VARIABLE mismatch "+ n1 +' or '+ n2 +" in component "+ str(x) + "!!!!!!!!!!!! \n")
                            error_flag=1
                        if n3==n4:
                            smt2_file.write (" RAIL SHORT ERROR: CHECK component "+ str(x)+ " inputs !!!!!!!!!!!! \n")
                            error_flag=1
                        if ((int(n3)>1) or (int(n4)>1)):
                            smt2_file.write (" RAIL Value does not fall in [0,1] ERROR: CHECK component "+ str(x)+ " inputs !!!!!!!!!!!! \n")
                            error_flag=1     
#                    self.component_info[self.num_component]['input_var1'].append(n1)
#                    self.component_info[self.num_component]['input_var2'].append(n2)
#                    self.component_info[self.num_component]['input_var1_rail1'].append(n3)
#                    self.component_info[self.num_component]['input_var2_rail2'].append(n4) 
            
            for x in range (1,self.num_component+1):
                if self.component_info[x]['reset']!=self.component_info[1]['reset']:
                    smt2_file.write (" RESET Error: Check Component "+ str(x)+ " and Component 1 reset inputs !!!!!!!!!!!! \n")
                    error_flag=1
                    
                    
                    
                    
#           #### CREATING FanOut structure for every component  ####            
            for x in range (1, self.num_component+1):
                self.component_info[x]['fanout']= []
                for y in range (1, self.num_component+1):
                    if (self.component_info[x]['outputs'][0] in self.component_info[y]['inputs']) and (str(y) not in self.component_info[x]['fanout'] ):
                        self.component_info[x]['fanout'].append(str(y))
                for z in range (1,self.num_component+1):
                    if self.component_info[x]['lack'] == self.component_info[z]['lack']:
                        for k in range (1, self.num_component+1):
                            if (self.component_info[z]['outputs'][0] in self.component_info[k]['inputs']) and (str(k) not in self.component_info[x]['fanout'] ):
                                self.component_info[x]['fanout'].append(str(k))
#                print (self.component_info[x]['fanout'])
 
#        #### Creating comp_FANIN STRUCTURE ###
            for x in range (1, self.num_component+1):
                s=[]
                self.component_info[x]['comp_fanin']=[]
#                ## If rack directly comes from lack of another PCHB element ##
                for a in range (1, self.num_component+1):
                    if (self.component_info[x]['rack'] == self.component_info[a]['lack']) and (str(a) not in self.component_info[x]['comp_fanin']):
                        self.component_info[x]['comp_fanin'].append(str(a))
#                print (self.component_info[x]['comp_fanin'])
#                        
                ## If rack comes from C element ##
               
                for a in range(1, self.num_comps+1):
                    if self.component_info[x]['rack'] == self.comp_info[a]['comp_outputs'][0]:
                        for n in self.comp_info[a]['comp_inputs']:
                            s.append(n)
#                print (s)
                    for m in s:
                        temp=[]
                        for n in range(1, self.num_comps+1):
                            if m == self.comp_info[n]['comp_outputs'][0]:
                                for b in self.comp_info[n]['comp_inputs']:
                                    temp.append(b)
                                for i in range(len(s)-1, -1, -1):
                                    if s[i] == m:
                                        s[i:i+1]= temp
                    for m in s:                    
                        for a in range (1, self.num_component+1):
                            if (m == self.component_info[a]['lack']) and (str(a) not in self.component_info[x]['comp_fanin']):
                                self.component_info[x]['comp_fanin'].append(str(a)) 
#                print (self.component_info[x]['comp_fanin'])               
#                print (s)   
#                print (self.component_info[x]['comp_fanin']) 
#            for x in range (1, self.num_component+1):
#                if (self.component_info[x]['comp_fanin']) != (self.component_info[x]['comp_fanin']):
#                    smt2_file.write ('ERROR IN COMPONENT ' + str(x) + ' CONNECTION!!!!')
#            
#        #### Checking condition starts here---------------------------------------####
#            
#            ## checking if fanout and comp_fanin are SUBSETs for bit-wise completion
            
            for x in range (1, self.num_component+1):
                flag=0
#                print (self.component_info[x]['fanout'], self.component_info[x]['comp_fanin'])
                if set(self.component_info[x]['fanout']) != set(self.component_info[x]['comp_fanin']):
                    flag=1
                    error_flag=1
#            ## checking if fanout and comp_fanin are PROPER SUBSETs for full-word completion
                if set(self.component_info[x]['fanout']) < set(self.component_info[x]['comp_fanin']):    
                    for m in self.component_info[x]['comp_fanin']:    
                        if (m not in self.component_info[x]['fanout']):
                            if int(self.component_info[x]['level']) <= int(self.component_info[int(m)]['level']):
                                error_flag=1
                                smt2_file.write ("WARNING: lack"+ m+ " signal comes from same or subsequent stage: SIGNAL NOT REQUIRED !!! \n")
                            if int(self.component_info[x]['level']) > int(self.component_info[int(m)]['level']):
                                flag=1
                                error_flag=1
                if flag==1:
                    smt2_file.write (" HANDSHAKING ERROR in PCHB element " + str(x) + " connection!!!!!!!!!!!! \n")
#                        
#            #### Checking the external RACK Signal Connections ####
            for a in range(1, self.num_component+1):
                s=[]
                flag=0
                if (self.component_info[a]['outputs'][0] in self.outputs):
#                    print ('yes')
                    if self.component_info[a]['rack'] == 'Rack':
                        flag=0
                    else:
                        for x in range (1, self.num_comps+1):
                            if self.component_info[a]['rack'] == self.comp_info[x]['comp_outputs'][0]:
#                                print ('yes')
                                for n in self.comp_info[x]['comp_inputs']:
                                    s.append(n) 
                                for m in s:
                                    temp=[]
                                    for n in range(1, self.num_comps+1):
                                        if m == self.comp_info[n]['comp_outputs'][0]:
                                            for b in self.comp_info[n]['comp_inputs']:
                                                temp.append(b)
                                            for i in range(len(s)-1, -1, -1):
                                                if s[i] == m:
                                                    s[i:i+1]= temp
#                        print(s)
                        if 'Rack' not in s:
                            error_flag=1
                            smt2_file.write ("External Rack Connection error in PCHB Element "+ str(a)+ " !!! \n")
#           
            ## Checking for the external LACK connections ##
            PI_var=[]
            for m in self.inputs:
                mat1= re.search (r'((?P<var>[A-z]+[0-9]+)_.*)',m)
                n= mat1.group('var')
                PI_var.append(n)
#            print (PI_var)   
            PI_fanout=[]
            for m in PI_var:
                for x in range(1, self.num_component+1):
#                    print(self.component_info[x]['input_var'])
                    for i in self.component_info[x]['input_var']:
                        if (str(m)==str(i)) and (str(x) not in PI_fanout): 
#                    if (m in self.component_info[x]['input_var']) and (str(x) not in PI_fanout):
                            PI_fanout.append(str(x))
#            print (PI_fanout, len (PI_fanout))
            for x in range (1, self.num_comps+1):
                s=[]
                Lack_fanin = []
                if self.comp_info[x]['comp_outputs'][0] == 'LACK':
                    for n in self.comp_info[x]['comp_inputs']:
                        s.append(n)
                        while s:
                            should_break = True
                            for m in s:
                                for n in range(1, self.num_comps+1):
                                    if m == self.comp_info[n]['comp_outputs'][0]:
                                        s.remove(m)
                                        for var in self.comp_info[n]['comp_inputs']:
                                            s.append(var)
                                        should_break = False
#                            print (s)                           
                            if should_break:
                                break;
#                if self.comp_info[x]['comp_outputs'][0] == 'LACK':
#                    for n in self.comp_info[x]['comp_inputs']:
#                        s.append(n) 
#                    for m in s:
#                        temp=[]
#                        for n in range(1, self.num_comps+1):
#                            if m == self.comp_info[n]['comp_outputs'][0]:
#                                for b in self.comp_info[n]['comp_inputs']:
#                                    temp.append(b)
#                                for i in range(len(s)-1, -1, -1):
#                                    if s[i] == m:
#                                        s[i:i+1]= temp
#                print(s)
                for j in s :
                    for x in range(1, self.num_component+1):
                        if j== self.component_info[x]['lack'] and (str(x) not in Lack_fanin):
                            Lack_fanin.append(str(x))
#            print(Lack_fanin, len(Lack_fanin))
            if set(PI_fanout) != set(Lack_fanin):
                error_flag=1
                smt2_file.write( "External LACK signal ERROR: Check the Primary INPUT Gate Connections!!! \n")
            
            
            if error_flag == 0:
                smt2_file.write("HANDSHAKING TEST SUCCESSFUL: NO HANDSHAKING ERROR in this circuit :) \n ")