; Formal verification proof - functional equivalence checking of test_netlist4+2x2MAC.txt
(set-logic QF_BV)

; Inputs: x0, x1, y0, y1
(declare-fun x0 () (_ BitVec 1))
(declare-fun x1 () (_ BitVec 1))
(declare-fun y0 () (_ BitVec 1))
(declare-fun y1 () (_ BitVec 1))

; Initial output states of: a0, a1, a2, a3
(declare-fun a0 () (_ BitVec 1))
(declare-fun a1 () (_ BitVec 1))
(declare-fun a2 () (_ BitVec 1))
(declare-fun a3 () (_ BitVec 1))

(declare-fun A_cs () (_ BitVec 4))

(declare-fun reset () (_ BitVec 1))

(define-fun bvRegD ((a (_ BitVec 1)) (reset (_ BitVec 1))) (_ BitVec 1)
	(ite (= reset (_ bv1 1)) (_ bv0 1) a) ) 

(define-fun bvha_sum ((a (_ BitVec 1)) (b (_ BitVec 1))) (_ BitVec 1)
	(bvxor a b)
)
(define-fun bvha_carry ((a (_ BitVec 1)) (b (_ BitVec 1))) (_ BitVec 1)
	(bvand a b)
)
(define-fun bvfa_sum ((a (_ BitVec 1)) (b (_ BitVec 1)) (cin (_ BitVec 1))) (_ BitVec 1)
	(bvxor a (bvxor b cin))
)
(define-fun bvfa_carry ((a (_ BitVec 1)) (b (_ BitVec 1)) (cin (_ BitVec 1))) (_ BitVec 1)
	(bvor (bvand a b) (bvor (bvand b cin) (bvand a cin) ) )
)
	
; SAT/UNSAT assertion for test_netlist4+2x2MAC.txt
(assert
	(not  
		(let
			(
				(p0 (bvand x0 y0))
				(t0 (bvand x1 y0))
				(t1 (bvand x0 y1))
				(p2 (bvand x1 y1))
			) 
		(let
			(
				(m0 (bvha_sum p0 a0))
				(c1 (bvha_carry p0 a0))
				(p1 (bvha_sum t0 t1))
				(c0 (bvha_carry t0 t1))
			) 
		(let
			(
				(p3 (bvha_sum p1 a1))
				(c2 (bvha_carry p1 a1))
				(p4 (bvfa_sum p2 a2 c0))
				(c3 (bvfa_carry p2 a2 c0))
				(a0_1 (bvRegD m0 (_ bv0 1)))
			) 
		(let
			(
				(m1 (bvha_sum p3 c1))
				(c4 (bvha_carry p3 c1))
			) 
		(let
			(
				(m2 (bvfa_sum p4 c4 c2))
				(c5 (bvfa_carry p4 c4 c2))
				(a1_1 (bvRegD m1 (_ bv0 1)))
			) 
		(let
				(
				(m3 (bvfa_sum c5 a3 c3))
				(c6 (bvfa_carry c5 a3 c3))
				(a2_1 (bvRegD m2 (_ bv0 1)))
				) 
		(let
			(
				(a3_1 (bvRegD m3 (_ bv0 1)))
			)
		(let
			(
				(out_pchb (concat a3_1 a2_1 a1_1 a0_1))
			)
		;        ------------------Sync Specification -------------------
		(let
			(
				(x_t (concat (_ bv0 2) x1 x0))
				(y_t (concat (_ bv0 2) y1 y0))
				(A (ite (= reset (_ bv1 1)) (_ bv0 4) A_cs))			
			)
		(let 
			(
				(z (bvmul x_t y_t))
			)
		(let 
			(
				(out_sync (bvadd z A))
			)
		(=>
			(and 
				(= reset (_ bv0 1)) (= A_cs (concat a3 a2 a1 a0)) 
			)
			(= out_pchb out_sync)
		) )))))))))) )
	)
)
(check-sat)
(get-model)