; Formal verification proof - functional equivalence checking of test_netlist_16+8x8MAC.txt
(set-logic QF_BV)

; Inputs: x0, x1, x2, x3, x4, x5, x6, x7, y0, y1, y2, y3, y4, y5, y6, y7
(declare-fun x0 () (_ BitVec 1))
(declare-fun x1 () (_ BitVec 1))
(declare-fun x2 () (_ BitVec 1))
(declare-fun x3 () (_ BitVec 1))
(declare-fun x4 () (_ BitVec 1))
(declare-fun x5 () (_ BitVec 1))
(declare-fun x6 () (_ BitVec 1))
(declare-fun x7 () (_ BitVec 1))
(declare-fun y0 () (_ BitVec 1))
(declare-fun y1 () (_ BitVec 1))
(declare-fun y2 () (_ BitVec 1))
(declare-fun y3 () (_ BitVec 1))
(declare-fun y4 () (_ BitVec 1))
(declare-fun y5 () (_ BitVec 1))
(declare-fun y6 () (_ BitVec 1))
(declare-fun y7 () (_ BitVec 1))

; Initial register output states of: a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15
(declare-fun a0 () (_ BitVec 1))
(declare-fun a1 () (_ BitVec 1))
(declare-fun a2 () (_ BitVec 1))
(declare-fun a3 () (_ BitVec 1))
(declare-fun a4 () (_ BitVec 1))
(declare-fun a5 () (_ BitVec 1))
(declare-fun a6 () (_ BitVec 1))
(declare-fun a7 () (_ BitVec 1))
(declare-fun a8 () (_ BitVec 1))
(declare-fun a9 () (_ BitVec 1))
(declare-fun a10 () (_ BitVec 1))
(declare-fun a11 () (_ BitVec 1))
(declare-fun a12 () (_ BitVec 1))
(declare-fun a13 () (_ BitVec 1))
(declare-fun a14 () (_ BitVec 1))
(declare-fun a15 () (_ BitVec 1))

(declare-fun reset () (_ BitVec 1))
(declare-fun A_cs () (_ BitVec 16))


(define-fun bvRegD ((a (_ BitVec 1 )) (reset (_ BitVec 1))) (_ BitVec 1)						
 (ite (= reset (_ bv1 1)) (_ bv0 1) a) )


(define-fun bvha_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvxor a b) )

(define-fun bvha_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvand a b) )


(define-fun bvfa_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvxor a (bvxor b cin)) )

(define-fun bvfa_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvor (bvand a b) (bvor (bvand b cin) (bvand a cin)))  )

; SAT/UNSAT assertion for test_netlist_16+8x8MAC.txt
(assert
	(not		
		(let
			(
				(p0 (bvand x0 y0))
				(t1 (bvand x1 y0))
				(t2 (bvand x2 y0))
				(t3 (bvand x3 y0))
				(t4 (bvand x4 y0))
				(t5 (bvand x5 y0))
				(t6 (bvand x6 y0))
				(t7 (bvand x7 y0))
				(t8 (bvand x0 y1))
				(t9 (bvand x1 y1))
				(t10 (bvand x2 y1))
				(t11 (bvand x3 y1))
				(t12 (bvand x4 y1))
				(t13 (bvand x5 y1))
				(t14 (bvand x6 y1))
				(t15 (bvand x7 y1))
				(t16 (bvand x0 y2))
				(t17 (bvand x1 y2))
				(t18 (bvand x2 y2))
				(t19 (bvand x3 y2))
				(t20 (bvand x4 y2))
				(t21 (bvand x5 y2))
				(t22 (bvand x6 y2))
				(t23 (bvand x7 y2))
				(t24 (bvand x0 y3))
				(t25 (bvand x1 y3))
				(t26 (bvand x2 y3))
				(t27 (bvand x3 y3))
				(t28 (bvand x4 y3))
				(t29 (bvand x5 y3))
				(t30 (bvand x6 y3))
				(t31 (bvand x7 y3))
				(t32 (bvand x0 y4))
				(t33 (bvand x1 y4))
				(t34 (bvand x2 y4))
				(t35 (bvand x3 y4))
				(t36 (bvand x4 y4))
				(t37 (bvand x5 y4))
				(t38 (bvand x6 y4))
				(t39 (bvand x7 y4))
				(t40 (bvand x0 y5))
				(t41 (bvand x1 y5))
				(t42 (bvand x2 y5))
				(t43 (bvand x3 y5))
				(t44 (bvand x4 y5))
				(t45 (bvand x5 y5))
				(t46 (bvand x6 y5))
				(t47 (bvand x7 y5))
				(t48 (bvand x0 y6))
				(t49 (bvand x1 y6))
				(t50 (bvand x2 y6))
				(t51 (bvand x3 y6))
				(t52 (bvand x4 y6))
				(t53 (bvand x5 y6))
				(t54 (bvand x6 y6))
				(t55 (bvand x7 y6))
				(t56 (bvand x0 y7))
				(t57 (bvand x1 y7))
				(t58 (bvand x2 y7))
				(t59 (bvand x3 y7))
				(t60 (bvand x4 y7))
				(t61 (bvand x5 y7))
				(t62 (bvand x6 y7))
				(t63 (bvand x7 y7))
			)		
		(let
			(
				(p1 (bvha_sum t1 t8))
				(c0 (bvha_carry t1 t8))
				(m0 (bvha_sum p0 a0))
				(c80 (bvha_carry p0 a0))
			)		
		(let
			(
				(s1 (bvfa_sum t2 t9 c0))
				(c1 (bvfa_carry t2 t9 c0))
				(m1 (bvfa_sum p1 a1 c80))
				(c81 (bvfa_carry p1 a1 c80))
			)		
		(let
			(
				(s2 (bvfa_sum t3 t10 c1))
				(c2 (bvfa_carry t3 t10 c1))
				(p2 (bvha_sum s1 t16))
				(c8 (bvha_carry s1 t16))
				(a0_1 (bvRegD m0 (_ bv0 1)))
			)		
		(let
			(
				(s3 (bvfa_sum t4 t11 c2))
				(c3 (bvfa_carry t4 t11 c2))
				(s9 (bvfa_sum s2 t17 c8))
				(c9 (bvfa_carry s2 t17 c8))
				(m2 (bvfa_sum p2 a2 c81))
				(c82 (bvfa_carry p2 a2 c81))
				(a1_1 (bvRegD m1 (_ bv0 1)))
			)		
		(let
			(
				(s4 (bvfa_sum t5 t12 c3))
				(c4 (bvfa_carry t5 t12 c3))
				(s10 (bvfa_sum s3 t18 c9))
				(c10 (bvfa_carry s3 t18 c9))
				(p3 (bvha_sum s9 t24))
				(c16 (bvha_carry s9 t24))
			)		
		(let
			(
				(s5 (bvfa_sum t6 t13 c4))
				(c5 (bvfa_carry t6 t13 c4))
				(s11 (bvfa_sum s4 t19 c10))
				(c11 (bvfa_carry s4 t19 c10))
				(s17 (bvfa_sum s10 t25 c16))
				(c17 (bvfa_carry s10 t25 c16))
				(m3 (bvfa_sum p3 a3 c82))
				(c83 (bvfa_carry p3 a3 c82))
				(a2_1 (bvRegD m2 (_ bv0 1)))
			)		
		(let
			(
				(s6 (bvfa_sum t7 t14 c5))
				(c6 (bvfa_carry t7 t14 c5))
				(s12 (bvfa_sum s5 t20 c11))
				(c12 (bvfa_carry s5 t20 c11))
				(s18 (bvfa_sum s11 t26 c17))
				(c18 (bvfa_carry s11 t26 c17))
				(p4 (bvha_sum s17 t32))
				(c24 (bvha_carry s17 t32))
			)		
		(let
			(
				(s7 (bvha_sum t15 c6))
				(c7 (bvha_carry t15 c6))
				(s13 (bvfa_sum s6 t21 c12))
				(c13 (bvfa_carry s6 t21 c12))
				(s19 (bvfa_sum s12 t27 c18))
				(c19 (bvfa_carry s12 t27 c18))
				(s25 (bvfa_sum s18 t33 c24))
				(c25 (bvfa_carry s18 t33 c24))
				(m4 (bvfa_sum p4 a4 c83))
				(c84 (bvfa_carry p4 a4 c83))
				(a3_1 (bvRegD m3 (_ bv0 1)))
			)		
		(let
			(
				(s14 (bvfa_sum s7 t22 c13))
				(c14 (bvfa_carry s7 t22 c13))
				(s20 (bvfa_sum s13 t28 c19))
				(c20 (bvfa_carry s13 t28 c19))
				(s26 (bvfa_sum s19 t34 c25))
				(c26 (bvfa_carry s19 t34 c25))
				(p5 (bvha_sum s25 t40))
				(c32 (bvha_carry s25 t40))
			)		
		(let
			(
				(s15 (bvfa_sum c7 t23 c14))
				(c15 (bvfa_carry c7 t23 c14))
				(s21 (bvfa_sum s14 t29 c20))
				(c21 (bvfa_carry s14 t29 c20))
				(s27 (bvfa_sum s20 t35 c26))
				(c27 (bvfa_carry s20 t35 c26))
				(s33 (bvfa_sum s26 t41 c32))
				(c33 (bvfa_carry s26 t41 c32))
				(m5 (bvfa_sum p5 a5 c84))
				(c85 (bvfa_carry p5 a5 c84))
				(a4_1 (bvRegD m4 (_ bv0 1)))
			)		
		(let
			(
				(s22 (bvfa_sum s15 t30 c21))
				(c22 (bvfa_carry s15 t30 c21))
				(s28 (bvfa_sum s21 t36 c27))
				(c28 (bvfa_carry s21 t36 c27))
				(s34 (bvfa_sum s27 t42 c33))
				(c34 (bvfa_carry s27 t42 c33))
				(p6 (bvha_sum s33 t48))
				(c40 (bvha_carry s33 t48))
			)		
		(let
			(
				(s23 (bvfa_sum c15 t31 c22))
				(c23 (bvfa_carry c15 t31 c22))
				(s29 (bvfa_sum s22 t37 c28))
				(c29 (bvfa_carry s22 t37 c28))
				(s35 (bvfa_sum s28 t43 c34))
				(c35 (bvfa_carry s28 t43 c34))
				(s41 (bvfa_sum s34 t49 c40))
				(c41 (bvfa_carry s34 t49 c40))
				(m6 (bvfa_sum p6 a6 c85))
				(c86 (bvfa_carry p6 a6 c85))
				(a5_1 (bvRegD m5 (_ bv0 1)))
			)		
		(let
			(
				(s30 (bvfa_sum s23 t38 c29))
				(c30 (bvfa_carry s23 t38 c29))
				(s36 (bvfa_sum s29 t44 c35))
				(c36 (bvfa_carry s29 t44 c35))
				(s42 (bvfa_sum s35 t50 c41))
				(c42 (bvfa_carry s35 t50 c41))
				(p7 (bvha_sum s41 t56))
				(c48 (bvha_carry s41 t56))
			)		
		(let
			(
				(s31 (bvfa_sum c23 t39 c30))
				(c31 (bvfa_carry c23 t39 c30))
				(s37 (bvfa_sum s30 t45 c36))
				(c37 (bvfa_carry s30 t45 c36))
				(s43 (bvfa_sum s36 t51 c42))
				(c43 (bvfa_carry s36 t51 c42))
				(p8 (bvfa_sum s42 t57 c48))
				(c49 (bvfa_carry s42 t57 c48))
				(m7 (bvfa_sum p7 a7 c86))
				(c87 (bvfa_carry p7 a7 c86))
				(a6_1 (bvRegD m6 (_ bv0 1)))
			)		
		(let
			(
				(s38 (bvfa_sum s31 t46 c37))
				(c38 (bvfa_carry s31 t46 c37))
				(s44 (bvfa_sum s37 t52 c43))
				(c44 (bvfa_carry s37 t52 c43))
				(p9 (bvfa_sum s43 t58 c49))
				(c50 (bvfa_carry s43 t58 c49))
				(m8 (bvfa_sum p8 a8 c87))
				(c88 (bvfa_carry p8 a8 c87))
			)		
		(let
			(
				(s39 (bvfa_sum c31 t47 c38))
				(c39 (bvfa_carry c31 t47 c38))
				(s45 (bvfa_sum s38 t53 c44))
				(c45 (bvfa_carry s38 t53 c44))
				(p10 (bvfa_sum s44 t59 c50))
				(c51 (bvfa_carry s44 t59 c50))
				(m9 (bvfa_sum p9 a9 c88))
				(c89 (bvfa_carry p9 a9 c88))
				(a7_1 (bvRegD m7 (_ bv0 1)))
			)		
		(let
			(
				(s46 (bvfa_sum s39 t54 c45))
				(c46 (bvfa_carry s39 t54 c45))
				(p11 (bvfa_sum s45 t60 c51))
				(c52 (bvfa_carry s45 t60 c51))
				(m10 (bvfa_sum p10 a10 c89))
				(c90 (bvfa_carry p10 a10 c89))
				(a8_1 (bvRegD m8 (_ bv0 1)))
			)		
		(let
			(
				(s47 (bvfa_sum c39 t55 c46))
				(c47 (bvfa_carry c39 t55 c46))
				(p12 (bvfa_sum s46 t61 c52))
				(c53 (bvfa_carry s46 t61 c52))
				(m11 (bvfa_sum p11 a11 c90))
				(c91 (bvfa_carry p11 a11 c90))
				(a9_1 (bvRegD m9 (_ bv0 1)))
			)		
		(let
			(
				(p13 (bvfa_sum s47 t62 c53))
				(c54 (bvfa_carry s47 t62 c53))
				(m12 (bvfa_sum p12 a12 c91))
				(c92 (bvfa_carry p12 a12 c91))
				(a10_1 (bvRegD m10 (_ bv0 1)))
			)		
		(let
			(
				(p14 (bvfa_sum c47 t63 c54))
				(p15 (bvfa_carry c47 t63 c54))
				(m13 (bvfa_sum p13 a13 c92))
				(c93 (bvfa_carry p13 a13 c92))
				(a11_1 (bvRegD m11 (_ bv0 1)))
			)		
		(let
			(
				(m14 (bvfa_sum p14 a14 c93))
				(c94 (bvfa_carry p14 a14 c93))
				(a12_1 (bvRegD m12 (_ bv0 1)))
			)		
		(let
			(
				(m15 (bvfa_sum p15 a15 c94))
				(c95 (bvfa_carry p15 a15 c94))
				(a13_1 (bvRegD m13 (_ bv0 1)))
			)		
		(let
			(
				(a14_1 (bvRegD m14 (_ bv0 1)))
			)		
		(let
			(
				(a15_1 (bvRegD m15 (_ bv0 1)))
			)
		(let
			(
				(out_pchb (concat a15_1 a14_1 a13_1 a12_1 a11_1 a10_1 a9_1 a8_1 a7_1 a6_1 a5_1 a4_1 a3_1 a2_1 a1_1 a0_1))
			)
				;        ------------------Sync Specification -------------------
		(let
			(
				(x_t (concat (_ bv0 8) x7 x6 x5 x4 x3 x2 x1 x0))
				(y_t (concat (_ bv0 8) y7 y6 y5 y4 y3 y2 y1 y0))
				(A (ite (= reset (_ bv1 1)) (_ bv0 16) A_cs))			
			)
		(let 
			(
				(z (bvmul x_t y_t))
			)
		(let 
			(
				(out_sync (bvadd z A))
			)
		(=>
			(and 
				(= reset (_ bv0 1)) (= A_cs (concat a15 a14 a13 a12 a11 a10 a9 a8 a7 a6 a5 a4 a3 a2 a1 a0)) 
			)
			(= out_pchb out_sync)	
		) )))))))))) )))))))))) )))))))))
	)
)
(check-sat)
(get-model)
(get-value (x0))
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (x5))
(get-value (x6))
(get-value (x7))
(get-value (y0))
(get-value (y1))
(get-value (y2))
(get-value (y3))
(get-value (y4))
(get-value (y5))
(get-value (y6))
(get-value (y7))