; Formal verification proof - functional equivalence checking of test_netlist_8+4x4MAC.txt
(set-logic QF_BV)

; Inputs: x0, x1, x2, x3, y0, y1, y2, y3
(declare-fun x0 () (_ BitVec 1))
(declare-fun x1 () (_ BitVec 1))
(declare-fun x2 () (_ BitVec 1))
(declare-fun x3 () (_ BitVec 1))
(declare-fun y0 () (_ BitVec 1))
(declare-fun y1 () (_ BitVec 1))
(declare-fun y2 () (_ BitVec 1))
(declare-fun y3 () (_ BitVec 1))

; Initial register output states of: a0, a1, a2, a3, a4, a5, a6, a7
(declare-fun a0 () (_ BitVec 1))
(declare-fun a1 () (_ BitVec 1))
(declare-fun a2 () (_ BitVec 1))
(declare-fun a3 () (_ BitVec 1))
(declare-fun a4 () (_ BitVec 1))
(declare-fun a5 () (_ BitVec 1))
(declare-fun a6 () (_ BitVec 1))
(declare-fun a7 () (_ BitVec 1))

(declare-fun reset () (_ BitVec 1))
(declare-fun A_cs () (_ BitVec 8))

(define-fun bvRegD ((a (_ BitVec 1 )) (reset (_ BitVec 1))) (_ BitVec 1)						
 (ite (= reset (_ bv1 1)) (_ bv0 1) a) )


(define-fun bvha_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvxor a b) )

(define-fun bvha_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvand a b) )


(define-fun bvfa_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvxor a (bvxor b cin)) )

(define-fun bvfa_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvor (bvand a b) (bvor (bvand b cin) (bvand a cin)))  )

; SAT/UNSAT assertion for test_netlist_8+4x4MAC.txt
(assert
	(not		
		(let
			(
				(p0 (bvand x0 y0))
				(t1 (bvand x1 y0))
				(t2 (bvand x0 y1))
				(t3 (bvand x2 y0))
				(t4 (bvand x1 y1))
				(t5 (bvand x3 y0))
				(t6 (bvand x2 y1))
				(t7 (bvand x3 y1))
				(t8 (bvand x0 y2))
				(t9 (bvand x1 y2))
				(t10 (bvand x2 y2))
				(t11 (bvand x3 y2))
				(t12 (bvand x0 y3))
				(t13 (bvand x1 y3))
				(t14 (bvand x2 y3))
				(t15 (bvand x3 y3))
			)		
		(let
			(
				(p1 (bvha_sum t1 t2))
				(c10 (bvha_carry t1 t2))
				(m0 (bvha_sum p0 a0))
				(c40 (bvha_carry p0 a0))
			)		
		(let
			(
				(s11 (bvfa_sum t3 t4 c10))
				(c11 (bvfa_carry t3 t4 c10))
				(m1 (bvfa_sum p1 a1 c40))
				(c41 (bvfa_carry p1 a1 c40))
			)		
		(let
			(
				(s12 (bvfa_sum t5 t6 c11))
				(c12 (bvfa_carry t5 t6 c11))
				(p2 (bvha_sum t8 s11))
				(c20 (bvha_carry t8 s11))
				(a0_1 (bvRegD m0 (_ bv0 1)))
			)		
		(let
			(
				(s13 (bvha_sum t7 c12))
				(c13 (bvha_carry t7 c12))
				(s21 (bvfa_sum t9 s12 c20))
				(c21 (bvfa_carry t9 s12 c20))
				(m2 (bvfa_sum p2 a2 c41))
				(c42 (bvfa_carry p2 a2 c41))
				(a1_1 (bvRegD m1 (_ bv0 1)))
			)		
		(let
			(
				(s22 (bvfa_sum t10 s13 c21))
				(c22 (bvfa_carry t10 s13 c21))
				(p3 (bvha_sum t12 s21))
				(c30 (bvha_carry t12 s21))
			)		
		(let
			(
				(s23 (bvfa_sum t11 c13 c22))
				(c23 (bvfa_carry t11 c13 c22))
				(p4 (bvfa_sum t13 s22 c30))
				(c31 (bvfa_carry t13 s22 c30))
				(m3 (bvfa_sum p3 a3 c42))
				(c43 (bvfa_carry p3 a3 c42))
				(a2_1 (bvRegD m2 (_ bv0 1)))
			)		
		(let
			(
				(p5 (bvfa_sum t14 s23 c31))
				(c32 (bvfa_carry t14 s23 c31))
				(m4 (bvfa_sum p4 a4 c43))
				(c44 (bvfa_carry p4 a4 c43))
			)		
		(let
			(
				(p6 (bvfa_sum t15 c23 c32))
				(p7 (bvfa_carry t15 c23 c32))
				(m5 (bvfa_sum p5 a5 c44))
				(c45 (bvfa_carry p5 a5 c44))
				(a3_1 (bvRegD m3 (_ bv0 1)))
			)		
		(let
			(
				(m6 (bvfa_sum p6 a6 c45))
				(c46 (bvfa_carry p6 a6 c45))
				(a4_1 (bvRegD m4 (_ bv0 1)))
			)		
		(let
			(
				(m7 (bvfa_sum p7 a7 c46))
				(c47 (bvfa_carry p7 a7 c46))
				(a5_1 (bvRegD m5 (_ bv0 1)))
			)		
		(let
			(
				(a6_1 (bvRegD m6 (_ bv0 1)))
			)		
		(let
			(
				(a7_1 (bvRegD m7 (_ bv0 1)))
			)
		(let
			(
				(out_pchb (concat a7_1 a6_1 a5_1 a4_1 a3_1 a2_1 a1_1 a0_1))
			)
		;        ------------------Sync Specification -------------------
		(let
			(
				(x_t (concat (_ bv0 4) x3 x2 x1 x0))
				(y_t (concat (_ bv0 4) y3 y2 y1 y0))
				(A (ite (= reset (_ bv1 1)) (_ bv0 8) A_cs))			
			)
		(let 
			(
				(z (bvmul x_t y_t))
			)
		(let 
			(
				(out_sync (bvadd z A))
			)
		(=>
			(and 
				(= reset (_ bv0 1)) (= A_cs (concat a7 a6 a5 a4 a3 a2 a1 a0)) 
			)
			(= out_pchb out_sync)	
		) )))))))))) )))))))
	)
)
(check-sat)
(get-model)
(get-value (x0))
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (y0))
(get-value (y1))
(get-value (y2))
(get-value (y3))
